module TrileanValue
	False = 0
	True = 1
	Tri = 2
end

module TrileanUtils
	module_function
	def Parse(x, y = false)
		if [true, false].include? x
			if y
				return TrileanValue::Tri
			elsif x
				return TrileanValue::True
			else
				return TrileanValue::False
			end
		elsif x.is_a?(String)
			if x == "True" or x == "1"
				return TrileanValue::True
			elsif x == "Tri" or x == "2"
				return TrileanValue::Tri
			elsif x == "False" or x == "0"
				return TrileanValue::False
			else
				throw "Error: Invalid string input"
			end
		end
	end
	def CreateTable(x)
		if x.is_a?(Integer)
			case x
			when TrileanValue::False
				return [false, false]
			when TrileanValue::True
				return [true, false]
			when TrileanValue::Tri
				return [false, true]
			else
				throw "Error: Invalid argument at position 0"
			end
		end
	end
end

class Trilean

	attr_accessor :value
	attr_accessor :table
	attr_accessor :embedded

	def initialize(x, y = nil, z = nil)
		if x.is_a?(Integer)
			if x <= 2
				@value = x
				@table = TrileanUtils.CreateTable(@value)
				@embedded = y
			else
				throw "Error: Trilean values must range from 0 to 2"
			end
		elsif [true, false].include? x
			if [true, false].include? y
				@value = TrileanUtils.Parse(x, y)
				@table = TrileanUtils.CreateTable(@value)
				@embedded = z
			else
				@value = TrileanUtils.Parse(x)
				@table = TrileanUtils.CreateTable(@value)
				@embedded = y
			end
		elsif x.is_a?(String)
			@value = TrileanUtils.Parse(x)
			@table = TrileanUtils.CreateTable(@value)
			@embedded = y
		else
			throw "Invalid argument type. Type of first argument must either be number, boolean, or string. Type of second object must either be boolean or desired embedded object (for all patterns other than bool, bool, embedded). Type of third object must be desired embedded object (for pattern bool, bool, embedded)"
		end
	end
end
